<template>
    <div class="">
              <!-- Modal dbt -->
              <b-modal @shown="setTitle" @hidden="reset" size="xl"  ref="inputProlongementModal" id="my-modal" :title="title"   :hide-footer="true">
                <form class="" method="POST" @keydown="form.errors.clear($event.target.name)"  @change="form.errors.clear($event.target.name)">
                              <div class="row mb-3">
                                <div class="col-md-6 d-flex">
                                        <div class="flex-shrink-1 " style="width:5px;height:55px;background:red"></div>
                                        <div style="" >
                                                  <p class="mb-1 pl-2">  <span>{{client.nomComplet}}</span> </p>
                                                  <p class="mb-1 pl-2">{{client.telephone1}}  </p>
                                                  <p class="mb-1 pl-2">{{client.adresse}}   </p>
                                                  
                                        </div>
                                </div>
                                <div class="col-md-6 d-flex justify-content-end">
                                        <div class="" style="text" >
                                                  <p class="mb-1 pl-2">  <span>{{vehicule.libelle}}</span> </p>
                                                  <p class="mb-1 pl-2">
                                                    {{ vehicule.marque == undefined ? "": vehicule.marque.libelle  }}  
                                                  </p>
                                                  <p class="mb-1 pl-2">{{vehicule.plaque_immatriculation}}   </p>
                                                  
                                        </div>
                                        <div class="flex-shrink-1 " style="width:5px;height:55px;background:red;margin-left:2px"></div>

                                </div>
                              </div>
                              <div class="form-group">
                                  <div class="row">
                                      <div class="col">
                                          <label class="">Date de début de la location</label>
                                          <datetime placeholder="Date de début de la location " ref="date_dbt" v-model="date_dbt" :min-datetime="min_date" :max-datetime="max_date" @input="datepickerEvent($event,'date_dbt')"  class="theme-rouge"  type="datetime" :input-class="['form-control input','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>

                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_dbt')" v-text="form.errors.get('date_dbt')"></span>

                                      </div>
                                      <div class="col">
                                          <label class="">Date de fin de la location</label>
                                          <datetime placeholder="Date de fin de la location " ref="date_fin_prev" v-model="date_fin_prev" :min-datetime="min_date_fin_prev"  @input="datepickerEvent($event,'date_fin_prev')"  class="theme-rouge"  type="datetime" :input-class="['form-control','input']"   :phrases="{ cancel: 'Annuler',ok: 'Ok'}"></datetime>

                                          <span class="m-form__help m--font-danger"  v-if="form.errors.has('date_fin_prev')" v-text="form.errors.get('date_fin_prev')"></span>
                                      </div>
                                      <div class="col-md-2">
                                          <label class="">Nbr de jours</label>
                                          <input class="form-control" type="text" disabled v-model="duree">
                                      </div>
                                  </div>
                              </div>
                                <div class="form-group">
                                  <div class="row">

                                      <div class="col">
                                            <label class="">Prix quotidien de la location</label>
                                            <input  class="form-control " :class="['form-control form-control-md',form.errors.has('tarif')?'is-invalid':'']"  name="tarif" v-model="form.tarif" type="text"/>
                                            <span class="m-form__help m--font-danger"  v-if="form.errors.has('tarif')" v-text="form.errors.get('tarif')"></span>
                                      </div>
                                  
                                                        <div class="col">
                                                            <label class="">Statut du payement</label>
                                                         <multi-select  :class="['',form.errors.has('statut_payement_id')?'is-invalid':'']" 
                                                         no-ptions="Aucun revendeur disponible" open-direction="bottom" 
                                                          v-model="selectedStatut"  :options="options.payements" 
                                                          @input="onStatutSelect"
                                                          :show-labels="false" :searchable="false" :clear-on-select="false" 
                                                          :close-on-select="true"  placeholder="Choisir le statut du payement" label="nature" track-by="id">
                                                      </multi-select>
                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('statut_payement_id')" v-text="form.errors.get('statut_payement_id')"></span>

                                                        </div>
                                                        <div class="col" v-if="avance">
                                                            <label class="">Avance</label>
                                                            <input placeholder="Entrez le montant" class="form-control " :class="['form-control',form.errors.has('avance')?'is-invalid':'']"  name="avance" v-model="form.avance" type="text"/>

                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('avance')" v-text="form.errors.get('avance')"></span>

                                                        </div>
                                                        <div class="col" v-show="false">
                                                            <label class="">Reste à payer</label>
                                                            <input disabled  class="form-control " :class="['form-control']"  v-model="reste"  type="text"/>
                                                        </div>
                                                    </div>
                              </div>
                              <div class="form-group mb-0">
                                  <div class="row">
                                          <div class="col-md-4">
                                              <div class="row">
                                                  <div class=" form-group col-md-12">
                                                      <label class="">Observations</label>
                                                      <textarea style="min-height:123px" class="form-control " :class="['form-control',form.errors.has('observation')?'is-invalid':'']"  name="observation" v-model="form.observation" type="text"></textarea>
                                                      <span class="m-form__help m--font-danger"  v-if="form.errors.has('observation')" v-text="form.errors.get('observation')"></span>
                                                      </div>
                                              </div>
                                          </div>
                                          <div class="col-md-8">
                                            <div class="table-responsive">
                                                  <table class="table">
                                                    <tbody>
                                                    <tr style="border-top:none">
                                                      <th style="border-top:none;width:50%">Tarif journalier:</th>
                                                      <td style="border-top:none">{{ monnaie(this.form.tarif) }} F cfa</td>
                                                    </tr>
                                                    <tr>
                                                      <th>Montant TTC:</th>
                                                      <td>{{ ttc }} F cfa</td>
                                                    </tr>
                                                    <tr v-if="avance">
                                                      <th>Avance:</th>
                                                      <td>{{ form.avance | monnaie }} F cfa</td>
                                                    </tr>
                                                    <tr v-if="avance">
                                                      <th >Reste à payer:</th>
                                                      <td>{{ reste | monnaie }} F cfa</td>
                                                    </tr>
                                                  </tbody></table>
                                                </div>
                                          </div>
                                  </div>
                              </div>
                                                    <div class="m-form__actions m-form__actions--solid" style="    display: flex;align-items: center;justify-content: flex-end;">
          <button @click="onSubmit()" type="button" :class="['btn btn-success btn-small mr-2',isLoading ? 'm-loader m-loader--sm m-loader--light m-loader--right' :'']" :disabled="form.errors.any() || isLoading">{{ isLoading ? "Processus en cours..." : ModalAction }}</button>
          <button @click="reset()" type="button" :class="['btn btn-secondary btn-small mr-2']" :disabled="isLoading ">Fermer</button>
    </div>

               </form>
                
            </b-modal>
            <!-- Modal fin -->
</div>
</template>

<script>
   import Form from "./../classes/Form"


    export default {
        data(){
            return{
                date_fin_prev:"",
                init:false,
                min_date_fin_prev:"",
                date_dbt:"",
                min_date:moment().format(),
                max_date:"",
                url:"/api/locations/prolongement",
                title:"Prolongement de Contrat N°: ",
                options:{
                  clients:[],
                  vehicules:[],
                  payements:[],
                },
                client:"",
                location:"",
                vehicule:"",
                selectedStatut:"",
                isLoading:false,
                form : new Form({
                  avec_chauffeur:false,
                  client_id:"",
                  vehicule_id:"",
                  avance:"",
                  date_dbt:"",
                  date_fin_prev:"",
                  nom_chauffeur:"",
                  nom_chauffeur_2:"",
                  livraison_effective:false,
                  client_est_chauffeur: false,
                  frais_livraison:0,
                  lavage_carburant:0,
                  niveau_carburant:"",
                  nbr_jour : 0,
                  observation:"",
                  location_id:'',
                  statut_payement_id:'',
                  tarif:"",
                  montant:"",
                  longue_duree:false,
                  zone_location:'',
                    client: {
                       nom:"",
                       prenom:"",
                       adresse:'',
                       telephone1:'',
                       ancien_client:false
                    },
                    vehicule :{
                       marque:"",
                       tvehicule:"",
                       immatriculation:"",
                       tarif:""
                    }
                }),
              
            }
        },
        created()
        {
           this.fetchOptions()
        },
        mounted() {
               window.event.$on("prolongement-event",(e)=>
               {
                  log(e)
                  this.vehicule = e.vehicule
                  this.location = e
                  this.form.location_id = e.id
                  this.client = e.client
                  this.onVehiculeSelect(e.vehicule)
                  this.onClientSelect(e.client)
                  this.showModalOnCreate()

                  this.date_fin_prev=""
                  this.date_dbt=""
                  this.form.avance=""
                  this.form.statut_payement_id=""
                  this.selectedStatut=""


                  var instant = moment(this.location.date_fin_prev);
                  if(instant.isAfter(moment()))
                  {
                    this.form.date_dbt = moment().add(1,'d').format()
                    this.date_dbt = moment(this.form.date_dbt).format()
                    this.min_date = moment(this.form.date_dbt).format()
                    this.min_date_fin_prev = moment(this.form.date_dbt).add(1,'days').format()
                  }
                  else
                  {
                    this.form.date_dbt = moment(this.location.date_fin_prev).add(1,'d').format()
                    this.date_dbt = moment(this.form.date_dbt).format()
                    this.min_date = moment(this.form.date_dbt).format()
                    this.min_date_fin_prev = moment(this.form.date_dbt).add(1,'days').format()
                  }
 
               })
        },
        computed:
         {

            ModalAction ()
            {
              return  this.modeEdit ? " Valider"  : "Valider"
            },
             ancien_client()
            {

              return this.form.client.ancien_client==true ? true : false
            
            },
             duree()
            {
                 
              if(isDefined(this.form.date_dbt) && isDefined(this.form.date_fin_prev)) 
                {
                  var start = moment(this.form.date_dbt,"YYYY-MM-DD"); //todays date
                  var end = moment(this.form.date_fin_prev,"YYYY-MM-DD"); // another date
                  var duration = moment.duration(end.diff(start));
                  this.form.nbr_jour = duration.asDays();

                  return  this.form.nbr_jour
                }
              else
                return 0
            
            },
             htc()
            {
               var montant = 0
               if(this.vehicule!="" && this.vehicule!=null && this.vehicule!=undefined )
               {
                  if(this.vehicule.hasOwnProperty('tarif'))
                    if(this.vehicule.tarif!=null)
                    {
                      if(this.duree<=0)
                      {
                        this.form.montant = 0
                        montant = 0
                      }
                      else
                      {
                        this.form.montant = this.duree * this.vehicule.tarif + (this.form.frais_livraison  + this.form.lavage_carburant)
                         montant = this.form.montant 
                      }

                    }
               }
               
               return montant
            },
            avance()
            {
                  if(isDefined(this.selectedStatut))
                  {
                       if(this.selectedStatut.nature=="avance")
                       return true
                  }
                 return false
            },
            reste()
            {
                 if(this.avance && this.form.nbr_jour>=1 && isDefined(this.form.avance))
                 {
                   return this.form.montant-this.form.avance;
                 }
                 return ""
            },
              ttc()
            {
                 this.form.montant = this.form.tarif  * this.duree
                 return this.form.montant
            }
         },
        methods: 
        {
                      //gere les datepickers
            datepickerEvent(event,name)
            {        if(isDefined(event))
                    {
                          if(name=='date_dbt')
                         {
                            var instant = moment(event)
                            this.form[name] = instant.format('YYYY-MM-DD HH:m')
                            this.min_date_fin_prev = moment(this.form[name]).add(1,'days').format()

                             if(this.init == true)
                             {
                               this.form.date_fin_prev =instant.add(1,'days').format('YYYY-MM-DD H:m')
                               this.date_fin_prev = instant.format()
                             }
                             this.init = true


                            if(this.form.errors.has('date_fin_prev'))
                            {
                              this.form.errors.clear('date_fin_prev')
                            }
                          
                         }
                         else if(name='date_fin_prev')
                         {
                            this.form[name] = moment(event).format('YYYY-MM-DD HH:m')
                            //this.max_date = moment(this.form[name]).subtract(1,'days').format()
                            
                         }
                    } 
                    else
                    {
                        
                        this.min_date = moment().format()
             
                    }  
                    this.form.checkError(name)
         

            },
            //Retire les erreurs des dates
            updateDate(e,val) 
            {
                  if(this.form.errors.has(val))
                    this.form.errors.clear(val)
                  
            },
            onStatutSelect(e)
            {
               if(e!=null)
               {
                  this.form.statut_payement_id = e.id
                  if(e.nature=="payé")
                  this.form.reste_a_payer = 0
               }
               else
               {
                 this.form.statut_payement_id_id = ""
  
               }


              if(this.form.errors.has('statut_payement_id') )
              {
                  this.form.errors.clear('statut_payement_id')
              }
            },
            fixChange(e)
            {
                if(e.target.checked==false)
                {
                    this.form.client_id = ""           
                }
                                
                this.form.client.nom=""
                this.form.client.prenom=""
                this.form.client.adresse=""
                this.form.client.telephone1=""
                this.selectedClient = ""
                if(this.form.client_est_chauffeur)
                this.form.nom_chauffeur = ""

                if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
                {
                    this.form.errors.clear('client_id')
                    this.form.errors.clear('client.nom')
                    this.form.errors.clear('client.prenom')
                    this.form.errors.clear('client.adresse')
                    this.form.errors.clear('client.telephone1')
                }

            },
            //Quand on selectionne un client
            onClientSelect(e)
            {
                    this.form.client_id = e.id
                    this.form.client.nom= e.nom
                    this.form.client.prenom= e.prenom
                    this.form.client.adresse= e.adresse
                    this.form.client.telephone1= e.telephone1

                if(this.form.errors.has('client_id') || this.form.errors.has('client.nom')|| this.form.errors.has('client.adresse') || this.form.errors.has('client.telephone1') || this.form.errors.has('client.prenom'))
                {
                    this.form.errors.clear('client_id')
                    this.form.errors.clear('client.nom')
                    this.form.errors.clear('client.prenom')
                    this.form.errors.clear('client.adresse')
                    this.form.errors.clear('client.telephone1')
                }
            },
              onVehiculeSelect(e)
            {
               this.form.vehicule_id = e.id
               this.form.vehicule.marque = e.marque.libelle
               this.form.vehicule.immatriculation = e.plaque_immatriculation
               this.form.vehicule.tarif = e.tarif
              

              if(this.form.errors.has('vehicule_id') )
              {
                  this.form.errors.clear('vehicule_id')
              }
            },
            monnaie: function(value) 
            {
               return  numeral(value).format('0,0');
            },
            setTitle: function() 
            {
               this.title =" Prolongement de location: "+this.vehicule.libelle  
            },
 
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset(false)
                this.$refs['inputProlongementModal'].show()
              
            },
              //Initialisation du formulaire
              reset(close=true)
             {
                  this.modeEdit = false
                  this.isLoading = false
                  this.form.client.nom =""
                  this.form.client.adresse =""
                  this.form.client.telephone1 =""
                  this.form.client.ancien_client =false
                  this.form.avec_chauffeur = false
                  this.form.client_est_chauffeur = false
                  this.form.longue_duree = false

                  this.form.date_dbt = ""
                  this.form.date_fin_prev = ""
                  this.form.nom_chauffeur = ""
                  this.form.nom_chauffeur_2 = ""
                  this.form.zone_location = ""
                  this.form.livraison_effective = false
                  this.form.tarif = this.location.tarif
                  this.form.errors.clearAll()
                  
                  if(close)
                  this.$refs['inputProlongementModal'].hide()
             },
            onChauffeurSelect(e)
            {
               if(e!=null)
               {
                this.form.chauffeur_id = e.id
               }
               else
               {
                 this.form.chauffeur_id = ""
                if(this.form.client_est_chauffeur)
                {
                    this.form.nom_chauffeur =""
                } 
               } 
               },
             //Charge les options
              fetchOptions()
             {
               axios.get("/api/dispatcher/options/locations").then((response) => 
                { 
                    
                      this.options.clients = response.data.clients
                      this.options.vehicules = response.data.vehicules
                      this.options.payements = response.data.payements

                      
                      //envoie un event pour signifier le chargement des options
                      this.$emit('initOption');
                },
                (error) =>
                {
                  this.isLoading = false
                });
             },
                          //Gere l'action du formulaire
             onSubmit()
             {
                 //On réinitialise le chargement
                this.isLoading = true
                //Requête ajax
                this.form.post(this.url).then((response) => 
                { 
                  if(response.success)
                  {
                        // on ramène les données sur la page 1
                        flash("<span>Location prolongée <strong>avec succes</strong></span>")
                        this.$emit('prolongement-done',response.entity);
                  }
                  else
                  {
                        flash("<span> Prolongation de la Location <strong> impossible</strong></span>","error")
                  }
                 this.reset()

                },
                (error) =>
                {
                  this.isLoading = false
                });  
             }
       },
        components:
        {

        },
        watch:
        {
          
        }
    }
</script>
<style lang="scss" scoped>
  #my-modal input[type="text"],#my-modal select
  {
        height: 40px;
        min-height: 40px;
  }
  .form-group {
    margin-bottom: 1.8rem;
}
#my-modal .modal-body
{
  overflow-x: hidden !important;
}
.modal-dialog-scrollable .modal-body {
      overflow-y: auto;
        overflow-x: hidden !important;

      
}
</style>